#ifdef WIN32
#undef PCUnix
#else
#define PCUnix 1
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <fcntl.h>
#define max_proc 1024
#ifdef WIN32
#include <windows.h>
#include <process.h>
#include <direct.h>
#include "get_opt.c"
void bzero(void *arg1,size_t arg2){memset(arg1,'\0',arg2);}
void sleep(int arg){Sleep(1000*arg);}
void WINAPI serviceProc(DWORD argc, LPSTR *argv);
void WINAPI serviceCtl(DWORD ctl);
int sendServiceStatus(DWORD serviceStatus);
SERVICE_STATUS_HANDLE hServStatus;
HANDLE hServEvnt;
DWORD  gServStatus;
SERVICE_TABLE_ENTRY st[]={{"Run_interval",serviceProc},{NULL,NULL}};
PROCESS_INFORMATION procInfo[max_proc];
#endif
#ifdef PCUnix
#include <unistd.h>
#include <syslog.h>
#include <pthread.h>
#endif
int proc_lock[max_proc];
int run_interval_flg=0;
char command[max_proc][256];
extern int optind;
extern char *optarg;
int main(int argc,char **argv){
	int ch,daemon_flg=0,usage(void),run_interval(void),init_daemon(void),proc_daemon(void);
#ifdef WIN32
	int add_service(void),rm_service(void),getServiceStatus(char *);
	OSVERSIONINFO osVersionInfo;
	osVersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osVersionInfo);

	if(osVersionInfo.dwPlatformId==VER_PLATFORM_WIN32_NT&&!getServiceStatus("Run_interval")&&StartServiceCtrlDispatcher(st))return(0);
#endif
	while((ch=getopt(argc,argv,"hDar"))!=-1){
		switch(ch){
			case 'h':
				usage();
				return(0);
				break;
#ifdef WIN32
			case 'a':
				add_service();
				return(0);
				break;
			case 'r':
				rm_service();
				return(0);
				break;
#endif
#ifdef PCUnix
			case 'D':
				daemon_flg=1;
				break;
#endif
		}
	}
	argc-=optind;
	argv+=optind;
	bzero(proc_lock,sizeof(proc_lock));
	bzero(command,sizeof(command));
	if(daemon_flg){
#ifdef PCUnix
		if(init_daemon()!=0){
			printf("init_daemon failed\n");
			return(1);
		}
		if(run_interval()!=0){
			printf("run_interval failed\n");
			return(1);
		}
#endif
	}
	else{
		run_interval();
	}
	exit(0);
}
int run_interval(void){
	int i,ncount,time[max_proc],timecount[max_proc],deleteFoot(char *),procIsLock(int),configDiv(char *,char *,char *);
	char str[256],str1[256],str2[256],*pt;
	FILE *stream;
#ifdef PCUnix
	pthread_t cthread[max_proc];
	void *crthread[max_proc];
#endif
	void run_interval_exit(int);
	void *run_interval_thread(void *);
	signal(SIGINT,&run_interval_exit);
	signal(SIGTERM,&run_interval_exit);
#ifdef PCUnix
	signal(SIGKILL,&run_interval_exit);
#endif
	ncount=0;
#ifdef WIN32
	GetModuleFileName(NULL,str1,256);
	if((pt=strrchr(str1,'\\'))!=NULL){
		*(pt+1)='\0';
		strcpy(str,str1);
		if(strlen(str)>0)_chdir(str);
	}
#endif
	if((stream=fopen("run_interval.txt","r"))==NULL){
#ifdef PCUnix
		syslog(3,"Config File (run_interval.txt) not Found");
#endif
#ifdef WIN32
		MessageBox(NULL,"Config File (run_interval.txt) not Found","Run_interval",MB_OK|MB_ICONWARNING);
#endif
		return(1);
	}
	while(fgets(str,256,stream)!=NULL){
		deleteFoot(str);
		if(configDiv(str,str1,str2)){
#ifdef PCUnix
			syslog(3,"Config File (run_interval.txt) Format Error");
#endif
#ifdef WIN32
			MessageBox(NULL,"Config File (run_interval.txt) Format Error","Run_interval",MB_OK|MB_ICONWARNING);
#endif
		}
		timecount[ncount]=atoi(str1);
		strcpy(command[ncount],str2);
		ncount++;
		if(ncount>max_proc)break;
	}
	fclose(stream);
	if(ncount==0){
		return(1);
	}
	for(i=0;i<ncount;i++){
		if(!procIsLock(i)){
			proc_lock[i]=1;
#ifdef PCUnix
			pthread_create(&cthread[i],NULL,run_interval_thread,(void *)i);
#endif
#ifdef WIN32
			_beginthread(run_interval_thread,0,(void *)i);
#endif
		}
	}
	bzero(time,sizeof(time));
	while(!run_interval_flg){
		sleep(1);
		for(i=0;i<ncount;i++){
			if(!procIsLock(i)&&timecount[i]!=0&&time[i]>=timecount[i]){
				proc_lock[i]=1;
#ifdef PCUnix
				pthread_create(&cthread[i],NULL,run_interval_thread,(void *)i);
#endif
#ifdef WIN32
				_beginthread(run_interval_thread,0,(void *)i);
#endif
				time[i]=0;
			}
			if(!procIsLock(i)){
				time[i]+=1;
			}
			if(timecount[i]==0)time[i]=0;
		}
	}
	for(i=0;i<ncount;i++){
#ifdef PCUnix
		if(procIsLock(i)){
			kill(0,SIGTERM);
			break;
		}
#endif
#ifdef WIN32
		if(procIsLock(i))TerminateProcess(procInfo[i].hProcess,SIGINT);
#endif
	}
	return(0);
}
void *run_interval_thread(void *arg){
#ifdef WIN32
	STARTUPINFO startupInfo;
	int argDiv(char *,char *,char *);
	char sarg[256],carg[256],str2[1024],*pt;
#endif
	char str1[1024];
#ifdef PCUnix
	void *retval;
	if(system(command[(int)arg])==127){
		sprintf(str1,"Command (%s) Execution Error",command[(int)arg]);
		syslog(3,str1);
	}
#endif
#ifdef WIN32
	argDiv(command[(int)arg],carg,sarg);
	strcpy(str1,carg);
	if((pt=strrchr(str1,'\\'))!=NULL){
		*(pt+1)='\0';
		strcpy(str2,str1);
		if(strlen(str2)>0){
			if(strlen(pt=getenv("PATH"))<sizeof(str1)-strlen(str2)&&strlen(pt)>0){
				strcpy(str1,"PATH=");
				strcat(str1,pt);
				strcat(str1,";");
				strcat(str1,str2);
			}
			else{
				strcpy(str1,"PATH=C:\\Windows\\System32;C:\\Windows;C:\\Windows\\System32\\Wbem;");
				strcat(str1,str2);
			}
			_putenv(str1);
		}
	}
	if(!CreateProcess(carg,sarg,NULL,NULL,FALSE,CREATE_NO_WINDOW|DETACHED_PROCESS,NULL,str2,&startupInfo,&procInfo[(int)arg])){
		sprintf(str1,"Command (%s) Execution Error",carg);
		MessageBox(NULL,str1,"Run_interval",MB_OK|MB_ICONWARNING);
	}
	WaitForSingleObject(procInfo[(int)arg].hProcess,INFINITE);
#endif
	if(!run_interval_flg)proc_lock[(int)arg]=0;
#ifdef WIN32
	CloseHandle(procInfo[(int)arg].hThread);
	CloseHandle(procInfo[(int)arg].hProcess);
	_endthread();
#endif
#ifdef PCUnix
	pthread_exit(retval);
#endif
}
int deleteFoot(char *str){
	int i;
	char *p;
	p=str;
	for(i=strlen(p)-1;i>0;i--){
		if(*(p+i)!='\n'&&*(p+i)!='\r'){
			*(p+i+1)='\0';
			break;
		}
	}
	return(0);
}
int configDiv(char *arg1,char *arg2,char *arg3){
	int i,j;
	char string[256],str[256],*pt,*p;
	strcpy(string,arg1);
	pt=string;
	if((p=strchr(pt,','))==NULL)return(1);
	*p='\0';
	j=0;
	for(i=0;i<strlen(pt);i++){
		if(*(pt+i)!=' '){
			str[j]=*(pt+i);
			j++;
		}
	}
	str[j]='\0';
	strcpy(arg2,str);
	pt=p+1;
	for(i=0;i<strlen(p+1);i++){
		if(*pt!=' ')break;
		pt++;
	}
	if(pt==NULL)return(1);
	strcpy(arg3,pt);
	return(0);
}
#ifdef PCUnix
int init_daemon(void){
	void run_interval_exit(int);
	switch(fork()){
		case -1:
			printf("fork error\n");
			return(1);
			break;
		case 0:
			setsid();
			break;
		default:
			exit(0);
	}
	close(0);
	close(1);
	close(2);
	open("/dev/null",O_RDWR);
	dup2(0,1);
	dup2(0,2);
	signal(SIGCHLD,SIG_IGN);
	signal(SIGHUP,&run_interval_exit);
	signal(SIGINT,&run_interval_exit);
	signal(SIGQUIT,&run_interval_exit);
	signal(SIGABRT,&run_interval_exit);
	signal(SIGTERM,&run_interval_exit);
	signal(SIGKILL,&run_interval_exit);
	return(0);
}
#endif
#ifdef WIN32
int argDiv(char *str,char *carg,char *sarg){
	char string[256],*p1,*p2,*p3;
	bzero(sarg,sizeof(sarg));
	strcpy(string,str);
	p1=string;
	if((p2=strchr(p1,' '))!=NULL){
		while(strchr(p2,'\\')!=NULL){
			p3=p2+1;
			if((p2=strchr(p3,' '))==NULL)break;
		}
		if(p2!=NULL)*p2='\0';
	}
	strcpy(carg,p1);
	if((p3=strrchr(p1,'\\'))!=NULL)p1=p3+1;
	strcat(sarg,p1);
	if(p2==NULL)return(0);
	strcat(sarg," ");
	p1=p2+1;
	while(strlen(p1)>0){
		if((p2=strchr(p1,' '))!=NULL)*p2='\0';
		if(strlen(p1)>0){
			if(p2!=NULL){
				strcat(sarg,p1);
				p1=p2+1;
			}
			else{
				strcat(sarg,p1);
				break;
			}
			strcat(sarg," ");
		}
		else{
			p1=p2+1;
		}
	}
	return(0);
}

int add_service(void){
	char str[256];
	SC_HANDLE hScm,hServ;
	hScm=OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS);
	if(hScm==NULL){
		printf("error on get service manager\n");
		return(0);
	}

	GetModuleFileName(NULL,str,256);
	hServ=CreateService(hScm,"Run_interval","Run_interval",SERVICE_ALL_ACCESS,SERVICE_WIN32_SHARE_PROCESS|SERVICE_INTERACTIVE_PROCESS,SERVICE_DEMAND_START,SERVICE_ERROR_NORMAL,str,NULL,NULL,NULL,"LocalSystem",NULL);
	if(hServ!=NULL){
		CloseServiceHandle(hServ);
		printf("service add success\n");
	}
	else{
		printf("error on service add\n");
	}

	CloseServiceHandle(hScm);
	return(0);
}
int rm_service(void){
	SC_HANDLE hScm,hServ;
	hScm=OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS);
	if(hScm==NULL){
		printf("error on get service manager\n");
		return(1);
	}

	hServ=OpenService(hScm,"Run_interval",DELETE);

	if(hServ==NULL){
		printf("error on get service\n");
		return(1);
	}

	if(!DeleteService(hServ)){
		printf("error on service remove\n");
		return(1);
	}

	CloseServiceHandle(hServ);
	CloseServiceHandle(hScm);
	printf("service remove success\n");

	return(0);  
}

void WINAPI serviceProc(DWORD argc,LPSTR *argv){
	int run_interval(void);
	hServStatus=RegisterServiceCtrlHandler("Run_interval",serviceCtl);
	if(hServStatus==NULL){
		printf("error on start service\n");
		return;
	}

//	sendServiceStatus(SERVICE_START_PENDING);

	hServEvnt=CreateEvent(NULL,0,0, NULL);

	sendServiceStatus(SERVICE_RUNNING);

	run_interval();

	CloseHandle(hServEvnt);

	sendServiceStatus(SERVICE_STOPPED);
}

void WINAPI serviceCtl(DWORD ctl){
	switch(ctl){
		case SERVICE_CONTROL_STOP:
			gServStatus = SERVICE_STOP_PENDING;
			SetEvent(hServEvnt);
			run_interval_flg=1;
			break;
		case SERVICE_CONTROL_SHUTDOWN:
			gServStatus = SERVICE_STOP_PENDING;
			SetEvent(hServEvnt);
			run_interval_flg=1;
			break;
	}
	return;
}

int sendServiceStatus(DWORD serviceStatus){
	SERVICE_STATUS servStatus;
	servStatus.dwServiceType=SERVICE_WIN32_SHARE_PROCESS|SERVICE_INTERACTIVE_PROCESS;
	servStatus.dwCurrentState=serviceStatus;
	servStatus.dwControlsAccepted=SERVICE_ACCEPT_STOP;
	servStatus.dwWin32ExitCode=0;
	servStatus.dwServiceSpecificExitCode=0;
	servStatus.dwCheckPoint=0;
	servStatus.dwWaitHint=0;
	SetServiceStatus(hServStatus, &servStatus);
	return(0);

}
int getServiceStatus(char *str){
	int flg=0;
	SC_HANDLE hScm,hServ;
	SERVICE_STATUS stat;
	hScm=OpenSCManager(NULL,NULL,SC_MANAGER_ALL_ACCESS);
	if(hScm==NULL)flg=1;
	hServ=OpenService(hScm,str,SERVICE_ALL_ACCESS);
	if(hServ==NULL)flg=1;
	if(!QueryServiceStatus(hServ,&stat))flg=1;
	if(stat.dwCurrentState!=SERVICE_START_PENDING)flg=1;
	CloseServiceHandle(hServ);
	CloseServiceHandle(hScm);
	return(flg);
}
#endif
int procIsLock(int proc_number){
	if(proc_lock[proc_number]==1)return(1);
	return(0);
}
void run_interval_exit(int sig){
	run_interval_flg=1;
}
int usage(void){
	printf("run_interval -h -D -a -r\noption :\n	-h Help\n	-D Deamon Mode\n	-a add service\n	-r remove service\nfiles :\n	run_interval.txt : <Time Interval in sec>,<Command>\n");
	return(0);
}